<?php
/*---------------------------------------------------------------*/
/*
    Titre : Convertisseur de fichiers XML en Array                                                                        
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=492
    Auteur           : napalm                                                                                             
    Date dition     : 21 Jan 2009                                                                                        
    Date mise  jour : 26 Sept 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
*/
/*---------------------------------------------------------------*/
   class XmlTree {

    private $m_aCol;
    
    // Construction de l'objet en lui passant le fichier à parser
    public function __construct($strFileName){
        $this->m_aCol    = Array();
        $fXml            = simplexml_load_file($strFileName);
        $this->m_aCol    = $this->build($fXml, $this->m_aCol);
    }
    
    // Fonction récursive de parcours du fichier XML
    private function build($oValues, $aInput){
        foreach($oValues as $strKey=>$value){
            if($value->children() || $value->attributes() ){
                $aInput[$strKey] = Array(); 
// Initialize an array in current key
                if($value->attributes()){    
// Separate attributes from elements
                    $aInput[$strKey] = $this->build($value->attributes(), 
$aInput[$strKey]);
                }
                if($value->children()){
                    $aInput[$strKey] = $this->build($value->children(), $aInput[
$strKey]);
                }
            }else{
                $aInput[$strKey] = (String)$value; 
// Cast SimpleXmlObject to a String
            }
        }
        return $aInput;
    }
    
    // Récupération d'un élément (nombre d'arguments illimité)
    public function element(){
        $nArgs = func_num_args();
        if($nArgs == 0){ return false; }
        $aOutput = $this->m_aCol;
        for($i=0 ; $i<$nArgs ; $i++){
            if(isset($aOutput[func_get_arg($i)])){
                $aOutput = $aOutput[func_get_arg($i)];
            }else{ return false; }
        }
        return $aOutput;
    }
    
}
?>